package com.singularity.util;

import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFPrintSetup;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.jodconverter.DocumentConverter;
import org.jodconverter.document.DefaultDocumentFormatRegistry;
import org.jodconverter.office.OfficeException;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.io.*;
import java.util.UUID;

@Component
public class OpenOfficeUtil {

//    @Resource
//    private DocumentConverter documentConverter;

    @Value("${file.path}")
    private String filePath;

    public void wordToPDF(String srcPath, String destPath) throws OfficeException {
        File file = new File(destPath);
//        documentConverter.convert(new File(srcPath)).to(file).as(DefaultDocumentFormatRegistry.PDF).execute();
    }

    public void wordToPDF(InputStream src,OutputStream tar) throws OfficeException {
//        documentConverter.convert(src).as(DefaultDocumentFormatRegistry.DOCX).to(tar).as(DefaultDocumentFormatRegistry.PDF).execute();
    }

    public void excelToPDF(InputStream src, OutputStream tar) throws OfficeException {
//        documentConverter.convert(src).as(DefaultDocumentFormatRegistry.XLSX).to(tar).as(DefaultDocumentFormatRegistry.PDF).execute();
    }

    /**
     * excel超范围预处理
     */
    public void refresh(String oldFilePath, String oldType, String newFilePath) throws IOException {
        Workbook workbook = null;
        if (oldType.equals("xls")) {
            workbook = new HSSFWorkbook(new FileInputStream(oldFilePath));
        } else if (oldType.equals("xlsx")) {
            workbook = new XSSFWorkbook(new FileInputStream(oldFilePath));
        }
        assert workbook != null;
        int sheetCount = workbook.getNumberOfSheets();
        for (int i = 0; i < sheetCount; i++) {
            Sheet sheet = workbook.getSheetAt(i);
            //通过此处即可将excel中所有列放置在一页显示（打印），转换至pdf后也将在一页显示
            XSSFPrintSetup printSetup = (XSSFPrintSetup) sheet.getPrintSetup();
            printSetup.setFitHeight((short) 0);
            sheet.setFitToPage(true);
        }
        workbook.write(new FileOutputStream(newFilePath));
    }

    /**
     * excel超范围预处理
     */
    public InputStream refresh(InputStream oldInputSteam, String oldType) throws IOException {
        Workbook workbook = null;
        if (oldType.equals("xls")) {
            workbook = new HSSFWorkbook(oldInputSteam);
        } else if (oldType.equals("xlsx")) {
            workbook = new XSSFWorkbook(oldInputSteam);
        }
        assert workbook != null;
        int sheetCount = workbook.getNumberOfSheets();
        for (int i = 0; i < sheetCount; i++) {
            Sheet sheet = workbook.getSheetAt(i);
            sheet.setHorizontallyCenter(true);//设置打印页面为水平居中
            sheet.getPrintSetup().setFitHeight((short) 0);
            sheet.setFitToPage(true);
        }
        String uuid = UUID.randomUUID().toString().replace("-", "");
        String newFilePath = filePath + uuid + "changedFile.xlsx";
        workbook.write(new FileOutputStream(newFilePath));
        return  new FileInputStream(newFilePath);
    }
}
